## Upload a schema `client.SchemaValidation.Schemas.New(ctx, params) (*PublicSchema, error)` **post** `/zones/{zone_id}/schema_validation/schemas` Uploads a new OpenAPI schema for API Shield schema validation. The schema defines expected request/response formats for API endpoints. ### Parameters - `params SchemaNewParams` - `ZoneID param.Field[string]` Path param: Identifier. - `Kind param.Field[SchemaNewParamsKind]` Body param: The kind of the schema - `const SchemaNewParamsKindOpenAPIV3 SchemaNewParamsKind = "openapi_v3"` - `Name param.Field[string]` Body param: A human-readable name for the schema - `Source param.Field[string]` Body param: The raw schema, e.g., the OpenAPI schema, either as JSON or YAML - `ValidationEnabled param.Field[bool]` Body param: An indicator if this schema is enabled ### Returns - `type PublicSchema struct{…}` A schema used in schema validation - `CreatedAt Time` - `Kind PublicSchemaKind` The kind of the schema - `const PublicSchemaKindOpenAPIV3 PublicSchemaKind = "openapi_v3"` - `Name string` A human-readable name for the schema - `SchemaID string` A unique identifier of this schema - `Source string` The raw schema, e.g., the OpenAPI schema, either as JSON or YAML - `ValidationEnabled bool` An indicator if this schema is enabled ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/option" "github.com/cloudflare/cloudflare-go/schema_validation" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) publicSchema, err := client.SchemaValidation.Schemas.New(context.TODO(), schema_validation.SchemaNewParams{ ZoneID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), Kind: cloudflare.F(schema_validation.SchemaNewParamsKindOpenAPIV3), Name: cloudflare.F("petstore schema"), Source: cloudflare.F(""), ValidationEnabled: cloudflare.F(true), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", publicSchema.SchemaID) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "locations": [ ".paths[\"/user/{username}\"].put" ], "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "locations": [ ".paths[\"/user/{username}\"].put" ], "pointer": "pointer" } } ], "result": { "created_at": "2014-01-01T05:20:00.12345Z", "kind": "openapi_v3", "name": "petstore schema", "schema_id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415", "source": "", "validation_enabled": true }, "success": true } ```